//STD
#include <string>
#include <vector>
#include <sstream>  
#include <deque>
#include <tuple>
#include <fstream>
#include <bits/stdc++.h> //explizit vector print help
#include <chrono>
#include <filesystem> 	//COPY FILE
#include <algorithm>	// std::sort
#include <omp.h>

//SDSL
#include <sdsl/int_vector.hpp>
#include <sdsl/int_vector_buffer.hpp>
#include <sdsl/rank_support.hpp>
#include <sdsl/rank_support_v5.hpp>

//EDSM HEADERS
#include "default_values.hpp"
#include "lib/include.hpp"

//EDSM PROGRAMS
#include "programs/include.hpp"

using namespace std;
using namespace sdsl;

int main(int argc,  char** argv){
	try{
		if(argc < 2) throw std::invalid_argument( "in edsm: " + edsm_io::missing_arguments);
		string arg = argv[1];
		if(arg == "-h" || arg == "--help"){			
			edsm_io::print_help_general(argv[0]);		
			exit(0);
		}

		if("parse" == arg)	return edsm_parse::main(argc, argv);
 		if("index" == arg)	return edsm_index::main(argc, argv);
		if("align" == arg)	return edsm_align::main(argc, argv);
		if("sample" == arg)	return edsm_sample::main(argc, argv);
		
		throw std::invalid_argument("in edsm: " + edsm_io::unknown_argument(arg));
	}catch(std::exception& e){		
		edsm_io::print_error(e.what());
		edsm_io::print_call_for_help(argv[0]);
		exit(1);
	}
	return 0;
}
